<?php
/**
 * Custom template tags for this theme
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package Blog Bee
 */
use BBE\Customizer\Theme_Defaults as Theme_Defaults;

if ( ! function_exists( 'blog_bee_posted_on' ) ) :
	/**
	 * Prints HTML with meta information for the current post-date/time.
	 */
	function blog_bee_posted_on( $post_id = '' ) {
		$time_string = '<time class="published updated" datetime="%1$s">%2$s</time>';
		$time = $post_id ? get_the_time( 'U', $post_id ) : get_the_time( 'U' );
		$modified_time = $post_id ? get_the_modified_time( 'U', $post_id ) : get_the_modified_time( 'U' );
		if( $time !== $modified_time ) {
			$time_string = '<time class="published" datetime="%1$s">%2$s</time><time class="updated" datetime="%3$s">%4$s</time>';
		}
		$time_string = sprintf(
			$time_string,
			esc_attr( $post_id ? get_the_date( DATE_W3C, $post_id ) : get_the_date( DATE_W3C ) ),
			esc_html( blog_bee_get_published_date( $post_id ) ),
			esc_attr( $post_id ? get_the_modified_date( DATE_W3C, $post_id ) : get_the_modified_date( DATE_W3C ) ),
			esc_html( blog_bee_get_modified_date( $post_id ) )
		);
		$year = get_the_date( 'Y' );
		$month = get_the_date( 'm' );
		$posted_on = '<a href="' . esc_url( get_month_link( $year, $month ) ) . '" rel="bookmark">' . $time_string . '</a>';
		echo '<span class="post-date posted-on">' . $posted_on . '</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
endif;

if ( ! function_exists( 'blog_bee_posted_by' ) ) :
	/**
	 * Prints HTML with meta information for the current author.
	 */
	function blog_bee_posted_by() {
		$byline = sprintf(
			/* translators: %s: post author. */
			esc_html_x( 'by %s', 'post author', 'blog-bee' ),
			'<span class="author vcard"><a class="url fn n" href="' . esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ) . '">' . esc_html( get_the_author() ) . '</a></span>'
		);

		echo '<span class="byline"> ' . $byline . '</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	}
endif;

if ( ! function_exists( 'blog_bee_entry_footer' ) ) :
	/**
	 * Prints HTML with meta information for the categories, tags and comments.
	 */
	function blog_bee_entry_footer() {
		edit_post_link(
			sprintf(
				wp_kses(
					/* translators: %s: Name of current post. Only visible to screen readers */
					__( 'Edit <span class="screen-reader-text">%s</span>', 'blog-bee' ),
					array(
						'span' => array(
							'class' => array(),
						),
					)
				),
				wp_kses_post( get_the_title() )
			),
			'<span class="edit-link">',
			'</span>'
		);
	}
endif;

if ( ! function_exists( 'blog_bee_post_thumbnail' ) ) :
	/**
	 * Displays an optional post thumbnail.
	 *
	 * Wraps the post thumbnail in an anchor element on index views, or a div
	 * element when on single views.
	 */
	function blog_bee_post_thumbnail( $size = 'post-thumbnail' ) {
		if ( post_password_required() || is_attachment() || ! has_post_thumbnail() ) {
			return;
		}

		if ( is_singular() ) :
			?>

			<div class="post-thumbnail">
				<?php the_post_thumbnail( $size ); ?>
			</div><!-- .post-thumbnail -->

		<?php else : ?>

			<a class="post-thumbnail" href="<?php the_permalink(); ?>">
				<?php
					the_post_thumbnail(
						$size,
						array(
							'alt' => the_title_attribute(
								array(
									'echo' => false,
								)
							),
						)
					);
				?>
			</a>

			<?php
		endif; // End is_singular().
	}
endif;

if ( ! function_exists( 'wp_body_open' ) ) :
	/**
	 * Shim for sites older than 5.2.
	 *
	 * @link https://core.trac.wordpress.org/ticket/12563
	 */
	function wp_body_open() {
		do_action( 'wp_body_open' );
	}
endif;

if( ! function_exists( 'blog_bee_get_published_date' ) ) :
	/**
	 * Get post pusblished date
	 * 
	 * @param int $post_id Id of post
	 * @since 1.0.0
	 */
	function blog_bee_get_published_date( $post_id = '' ) {
		$date_format = Theme_Defaults::get_theme_option( 'seo_misc_date_format' );
		if( $date_format == 'default' ) {
			$n_date = $post_id ? get_the_date( '', $post_id ) : get_the_date();
		} else {
			$timestamp = $post_id ? get_the_time( 'U', $post_id ) : get_the_time( 'U' );
			$n_date = human_time_diff( $timestamp, current_time( 'timestamp' ) ) . ' ' . __( 'ago', 'blog-bee' );
		}
		return apply_filters( "blog_bee_inherit_published_date", $n_date );
	}
endif;

if( ! function_exists( 'blog_bee_get_modified_date' ) ) :
	/**
	 * Get post modified date
	 * 
	 * @param int $post_id Id of post
	 * @since 1.0.0
	 */
	function blog_bee_get_modified_date( $post_id = '' ) {
		$date_format = Theme_Defaults::get_theme_option( 'seo_misc_date_format' );
		if( $date_format == 'default' ) {
			$n_date = $post_id ? get_the_modified_date( '', $post_id ) : get_the_modified_date();
		} else {
			$timestamp = $post_id ? get_the_modified_time( 'U', $post_id ) : get_the_modified_time( 'U' );
			$n_date = human_time_diff( $timestamp, current_time( 'timestamp' ) ) . ' ' . __( 'ago', 'blog-bee' );
		}
		return apply_filters( "blog_bee_inherit_published_date", $n_date );
	}
endif;

if( ! function_exists( 'blog_bee_tags_list' ) ) :
	/**
	 * print the html for tags list
	 */
	function blog_bee_tags_list() {
		// Hide category and tag text for pages.
		if ( 'post' === get_post_type() ) {
			/* translators: used between list items, there is a space after the comma */
			$tags_list = get_the_tag_list( '', esc_html_x( ' ', 'list item separator', 'blog-bee' ) );
			if ( $tags_list ) {
				/* translators: 1: list of tags. */
				printf( '<span class="tags-links">' . esc_html__( 'Tagged: %1$s', 'blog-bee' ) . '</span>', $tags_list ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
			}
		}
	}
endif;